package org.eclipse.spliteditor.handlers;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.IEditorPart;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.handlers.HandlerUtil;
import org.eclipse.ui.part.MultiEditorInput;

/**
 * @since 3.4
 *
 */
public class OpenMultiEditorHandler extends AbstractHandler {

	public Object execute(ExecutionEvent event) throws ExecutionException {
		IWorkbenchWindow activeWorkbenchWindow = HandlerUtil
				.getActiveWorkbenchWindow(event);
		IWorkbenchPage page = activeWorkbenchWindow.getActivePage();
		if (page == null) {
			return null;
		}
		IEditorPart editor = page.getActiveEditor();
		if (editor == null) {
			return null;
		}
		String editorId = editor.getSite().getId();
		if (editorId == null) {
			return null;
		}
		
		IEditorInput editorInput = editor.getEditorInput();
		
		MultiEditorInput input = new MultiEditorInput(
				new String[] { editorId, editorId },
				new IEditorInput[] { editorInput, editorInput });

//		ISelection sel = HandlerUtil.getCurrentSelectionChecked(event);
//		Object selObj = ((IStructuredSelection) sel).getFirstElement();
//		IFile file;
//		if (selObj instanceof ICompilationUnit) {
//			file = (IFile) ((ICompilationUnit) selObj).getResource();
//		} else {
//			file = (IFile) selObj;
//		}
//		MultiEditorInput input = new MultiEditorInput(new String[] {
//				"org.eclipse.jdt.ui.CompilationUnitEditor", //$NON-NLS-1$
//				"org.eclipse.jdt.ui.CompilationUnitEditor" }, //$NON-NLS-1$
//				new IEditorInput[] { new FileEditorInput(file),
//						new FileEditorInput(file) });

		try {
			page.openEditor(input,
					"org.eclipse.spliteditor.TiledEditor"); //$NON-NLS-1$
		} catch (PartInitException e) {
			throw new ExecutionException("oops", e); //$NON-NLS-1$
		}
		return null;
	}

}
